/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

//shopId = "e303744b-1330-4ae1-b945-2ab60446d5fa"; // !! DEBUG

var items = new Array(); // サーチ結果を保持
var panoramas = new Array(); // パノラマのリスト
var panoramaNameTbl = new Object(); // パノラマId->パノラマ名変換テーブル
var panoVisitList = new Object(); // パノラマ訪問済みリスト
var itemDetailCheckList = new Object(); // アイテム詳細閲覧リスト
var firstVisit = true;
var firstNaviClose = true;
var isipad = false;
var isiphone = false;
    
function searchItemButton (){
    if ($("#searchBoxContainer").is(":hidden")) {
        showSearchBox();
    }
    else {
        hideSearchBox();
    }
    hideItemDetail(); // とりあえずアイテム詳細ポップアップは閉じる
    hideSearchResultList(); // とりあえず検索結果ウインドウは閉じる
}



function opening()
{
    if (firstVisit) {
        if (!isiphone) { // iPhoneはイントロページを出さない
            showNaviPage('', '../../pvs/customize/nissen/nav_page1.html');
        }
        else{
            showNaviPage_iphone();
        }
        firstVisit = false;        
        }
}

function hideNaviPage()
{
    $("#popup_overlay").hide();
    $("#popup").hide();
    
    if (firstNaviClose) {
        var krpano = document.getElementById("krpanoSWFObject");  
        krpano.call("action(ready_affordance);");
    
        firstNaviClose = false;
    }
}
           
function showNaviPage(title, page)
{       
    // 画面サイズの取得
    var windowWidth = $(window).width();
    var windowHeight = $(window).height();
        
    $("#popup_overlay").css("width", windowWidth);
    $("#popup_overlay").css("height", windowHeight);    
     
    // iphone以外はヘッダ表示
    if (!isiphone) {
        $("#header").fadeIn();
    }

    // Popupセンタリング
    var w = 380;
    var h = 380;
    $("#popup").css("width", w);
    $("#popup").css("height", h);
    $("#popup").css("left", windowWidth / 2 - w / 2);
    $("#popup").css("top", windowHeight / 2 - h / 2);
                
    // ポップアップを表示
    $("#popup").show();
    $("#popup_overlay").show();
         
    // タイトルのセット
    $("#popup_caption").html(title);
              
    // 現在表示ページのファイル読み込み
    var httpObj = jQuery.get(page, null, function(){
        if (httpObj.responseText != null) {
            $("#popup_body").html(httpObj.responseText);
        }       
        
        // クローズボタン押したときの挙動
        $("#popup_closeWindow").click(function(){
            hideNaviPage();
        });        
    });
    
}

function showNaviPage_iphone(title, page)
{       
    // 画面サイズの取得
    var windowWidth = $(window).width();
    var windowHeight = $(window).height(); 

    // Popupセンタリング
    var w = 380;
    var h = 380;
    $("#popup_iphone").css("width", windowWidth - 20);
    $("#popup_iphone").css("height", windowHeight);
    $("#popup_iphone").css("left", 10);
    $("#popup_iphone").css("top", 10);
                
    // ポップアップを表示
    $("#popup_iphone").show();
         
              
    // 現在表示ページのファイル読み込み

    
}

function hideNaviPage_iphone()
{
    $("#popup_iphone").css("display","none");    
}



$(function(){

    // ＵＡ判定
    var agent = navigator.userAgent;
    
    if(agent.search(/iPhone/) > -1) {
        isiphone = true;
    } else if (agent.search(/iPad/) > -1) {
        isipad = true;
    }
        
    // loading表示
    $('span.loading').bind('ajaxStart', function() {
        $(this).show();
    }).bind('ajaxStop', function() {
        $(this).hide();
    });
    
   
    panoramaSearch(); // パノラマリスト取得
     
    // インクリメンタルサーチ
    /*
    $('#searchBox').bind('textchange', function() {
        //   console.log("searchword=" + $(this).val());
        itemSearch($(this).val(), null);
    });    
    */

        $("#searchBox").keypress(function() {
            if ($(this).val() != "") {
                itemSearch($(this).val(), null);
            }
        }); 
   
   
   
   
//   if (isiphone == false && isipad == false) {
//        // エンターキーを押したときサーチ
//        $("#searchBox").keypress(function() {
//            if ($(this).val() != "") {
//                itemSearch($(this).val(), null);
//            }
//        });   
//   } else {
//        /* タッチの開始時のイベント */
//        $('#searchBox').bind('touchstart', function() {
//            if ($(this).val() != "") {
//                itemSearch($(this).val(), null);
//            }
//        });     
//   }
   
    if (!isiphone) {
        $("#searchBoxContainer").addClass("searchBoxContainer_normal");
        $("#searchBox").addClass("searchBox_normal");
    }
    else {
        $("#searchBoxContainer").addClass("searchBoxContainer_iphone");
        $("#searchBoxContainerCloseBtn").css("top","3");
        $("#searchBoxContainerCloseBtn").css("right","7");
        $("#searchBox").addClass("searchBox_iphone");
        $("#searchResultBoxContainer").css("width","300");
        $("#searchResultList").css("width","290");
        $("#searchResultList").css("height","220");        
    }

    $("#panoramaListCloseBtnImage").click(function(){
        // エリアリスト閉じる
        hidePanoramaList();
        hideItemDetail(); // とりあえずアイテム詳細ポップアップは閉じる
        hideSearchResultList(); // とりあえず検索結果ウインドウは閉じる
    });    

    $("#searchBoxContainerCloseBtnImage").click(function(){
        hideSearchBox(); //　検索ボックス閉じる
        hideSearchResultList(); // 検索結果窓閉じる 
        hidePanoramaList(); // エリアリストもいちおう閉じる
        hideSearchBox();
        hideSearchResultList();
    });
    $("#searchBoxContainerCloseBtnImage_iPhone").click(function(){
        hideSearchBox(); //　検索ボックス閉じる
        hideSearchResultList(); // 検索結果窓閉じる 
        hidePanoramaList(); // エリアリストもいちおう閉じる
        hideSearchBox();
        hideSearchResultList();
    });
    $("#popup_iphone_button").click(function(){
        hideNaviPage_iphone();
    });
    


});

function GetFileName(file_url){
    file_url = file_url.substring(file_url.lastIndexOf("/")+1,file_url.length)
    //拡張子も取り除く場合は次の行のコメントアウトをはずしてください
    file_url = file_url.substring(0,file_url.indexOf("."));
    return file_url;
}

// 商品検索
function itemSearch(query, panoId) {
    //    var url = "http://localhost:81/ItemSearch.aspx?query=" + encodeURIComponent(query)+ "&shopid=" + shopId;
    var url = "http://cloud.panoplaza.com/ItemSearch.aspx?query=" + encodeURIComponent(query)+ "&shopid=" + shopId;
    if (panoId != null) {
        url += "&panoramaid=" + panoId;
    }

    $.ajax({
        url: url,
        dataType: 'jsonp',
        success: function (data) {
            //            console.log("result=" + data.items.length);
            makeSearchResultList(data);
            showSearchResultList();
        }
    });

    return false;
}

// パノラマ検索
function panoramaSearch() {
    //   var url = "http://localhost:81/PanoramaSearch.aspx?shopid=" + shopId + "&query=";
    var url = "http://cloud.panoplaza.com/PanoramaSearch.aspx?shopid=" + shopId + "&query=";

    $.ajax({
        url: url,
        dataType: 'jsonp',
        success: function (data) {
            //            console.log("pano count=" + data.items.length);
            makePanoramaList(data);      
            alignPanoramaList(); // パノラマリストの表示位置をセット
            showPanoramaName(); // パノラマ名を表示
        }
    });

    return false;
}

// スクリーンサイズ（ブラウザの表示領域）取得
function getScreenSize()
{
    var obj = new Object( );
        
//    obj.width = document.documentElement.clientWidth;
//    obj.height = document.documentElement.clientHeight;
    obj.width = document.documentElement.clientWidth || document.body.clientWidth || document.body.scrollWidth;
    obj.height = document.documentElement.clientHeight || document.body.clientHeight || document.body.scrollHeight;
    
//    console.log("screen width=" +  obj.width);
//    console.log("screen height=" +  obj.height);
        
    return obj;
}

// 検索窓を表示する
function showSearchBox()
{
    var size = getScreenSize();
      
    // 表示位置調整
    $("#searchBoxContainer").css("top", 0);
    $("#searchBoxContainer").css("left", size.width / 2 - $("#searchBoxContainer").width() / 2);
      
    // フェードイン表示（単なる演出）
    $("#searchBoxContainer").hide();
    $("#searchBoxContainer").fadeIn("slow");
    
    
    // 検索結果窓閉じる
    hideSearchResultList();  
     
    // エリアリストも閉じる
    hidePanoramaList();
}



// 検索窓を非表示にする
function hideSearchBox()
{
    $("#searchBoxContainer").hide();
}


// ショップ内のパノラマの一覧を取得しhtmlを作る
function makePanoramaList(data)
{
    panoramas.length = 0; // サーチ結果のリセット
    document.getElementById("panoramaList").innerHTML = ""; // htmlクリア

    for (var i = 0; i < data.items.length; i++) {
        //        console.log("panoId=" + data.items[i].panoramaId);
        
        panoramas[i] = data.items[i];
        
        // パノラマIdとパノラマ名の変換テーブルを作る
        panoramaNameTbl[data.items[i].panoramaId] = data.items[i].name;
               
        // html作成
        /*
        var html = "<div class='panoramaItem'>"
        + "<span class='panoramaItemCaption'>" + data.items[i].name + "</span>"
        + "</div>";
        */
        var html = "<div class='panoramaItem'>"
        + "<span class='panoramaItemCaption' panoid='" + data.items[i].panoramaId + "'>" + data.items[i].name + "</span>"
        + "</div>";
    
        document.getElementById("panoramaList").innerHTML += html;
    }

    // クリックしたときの挙動をセット
    $(".panoramaItem").click(function(){
        var itemno = $(".panoramaItem").index(this);
        expandSelectedPanorama(panoramas[itemno].panoramaId);
    });
}

// エリアリストを表示する
function showPanoramaList()
{    
    if ($("#panoramaListBoxContainer").is(":hidden")) {
        $("#panoramaListBoxContainer").slideDown("slow");
        
        // 検索窓を閉じる
        hideSearchBox();
 
        // 検索結果窓も閉じる
        hideSearchResultList();
    }
    else
    {
        hidePanoramaList();
    }  
}

// エリアリストを非表示にする
function hidePanoramaList()
{
    $("#panoramaListBoxContainer").css("display", "none");
}

// エリアリストを表示する位置を決める
function alignPanoramaList()
{
    var size = getScreenSize();
      
    // 表示位置調整
    var margin = 10;
    var top = size.height - $("#panoramaListBoxContainer").height() - 55 - margin;
  
    $("#panoramaListBoxContainer").css("top", top);
    $("#panoramaListBoxContainer").css("left", size.width / 2 - 500 );   
       
    // 位置をセットしたら非表示にする
    $("#panoramaListBoxContainer").hide();
}

// エリアをクリックしたとき
function expandSelectedPanorama(panoId)
{
    itemSearch("", panoId);
}

// アイテム検索結果からhtmlを作る
function makeSearchResultList(data)
{
    items.length = 0; // サーチ結果のリセット
    document.getElementById("searchResultList").innerHTML = ""; // htmlクリア

    for (var i = 0; i < data.items.length; i++) {
        items[i] = data.items[i];

        var imgurl = data.items[i].imgurl;
        if (imgurl == null) { // リンク画像がない場合
            imgurl = "../../pvs/customize/startupasia/noimage.jpg";
        }
        
        // html作成
        /*
        var html = "<div class='searchResultItem'>"
        + "<img src='" + imgurl + "' class='searchResultItemThumb'/>"
        + "<span class='searchResultItemCaption'>" + data.items[i].name + "</span>"
        + "</div>";
        */
        var html = "";
        if (itemDetailCheckList[data.items[i].itemHotSpotId] == true) {
            html = "<div class='searchResultItem'>"
            + "<img src='" + imgurl + "' class='searchResultItemThumb'/>"
            + "<span class='searchResultSelectedItemCaption'>" + data.items[i].name + "</span>"
            + "</div>";                
        } else {
            html = "<div class='searchResultItem'>"
            + "<img src='" + imgurl + "' class='searchResultItemThumb'/>"
            + "<span class='searchResultItemCaption'>" + data.items[i].name + "</span>"
            + "</div>";            
        }

        document.getElementById("searchResultList").innerHTML += html;
    }

    // クリックしたときの挙動をセット
    $(".searchResultItem").click(function(){
        var itemno = $(".searchResultItem").index(this);
        moveToSelectedItem(items[itemno].panoramaId, items[itemno].x, items[itemno].y);
    });   
}

// 商品検索結果を表示する
function showSearchResultList()
{
    var size = getScreenSize();
        
    // 表示位置調整
    
    $("#searchResultBoxContainer").css("left", size.width / 2 - $("#searchResultBoxContainer").width() / 2);
    
    if (!isiphone) {
        $("#searchResultBoxContainer").css("top", 155);
        $("#searchResultBoxContainer").css("left", size.width / 2 - $("#searchResultBoxContainer").width() / 2);
    }
    else {
        $("#searchResultBoxContainer").css("top", 95);
        $("#searchResultBoxContainer").css("left", size.width / 2 - $("#searchResultBoxContainer").width() / 2);
    }
}

// 商品検索結果を非表示にする
function hideSearchResultList()
{
    $("#searchResultBoxContainer").css("top", "-9999px");
    $("#searchResultBoxContainer").css("left", "-9999px");
    
    // エリアリストも閉じる
    hidePanoramaList();
}

// 選択した商品へ視点移動する
function moveToSelectedItem(panoramaId, x, y)
{
    var krpano = document.getElementById("krpanoSWFObject");
    var currentPanoId = GetFileName(krpano.get("xml.url")); // 現在のパノラマ

    hideSearchResultList();
    hidePanoramaList();
    hideSearchBox();
    
    if (currentPanoId == panoramaId) // 同じパノラマ内のアイテム
    {
        krpano.call("lookto(" + x + "," + y + ");");
    }
    else // 別のパノラマ内のアイテム
    {
        var panoxml = panoramaId + ".xml";
        
//        panoxml = "panorama1.xml"; // !! DEBUG
        
        var params = "view.hlookat=" + x + "&ampview.vlookat=" + y;
        krpano.call("loadpano('" + panoxml + "','" + params + "',null,NOBLEND);");        
    }
}

// マップ表示
function showMap()
{
    var krpano = document.getElementById("krpanoSWFObject");  
    krpano.call("action(zoommap_open);");
}

// パノラマ閲覧記録をつける
function updatePanoVisitList(id)
{
    panoVisitList[id] = true;
        
    // クラスを変更する
    $(".panoramaItemCaption[panoid=" + id + "]").addClass("panoramaSelectedItemCaption");
    $(".panoramaItemCaption[panoid=" + id + "]").removeClass("panoramaItemCaption");   
}

// アイテム詳細閲覧記録をつける
function updateItemDetailCheckList(id)
{
    itemDetailCheckList[id] = true;
}

// アイテム詳細ポップアップを閉じる(Flashのときのみ有効)
function hideItemDetail()
{
    var krpano = document.getElementById("krpanoSWFObject");  
    krpano.call("action(hideDetail);");
}


// パノラマIdを保持する
function setPanoramaId(id)
{
    panoId = id;    
    showPanoramaName();
}

function showPanoramaName()
{
//    panoId = "7a2fc012-5401-4078-bb69-0f4d4903c112"; // !! DEBUG
    //    console.log("panoName=" + panoramaNameTbl[panoId]);  

    $("#areaname").html(panoramaNameTbl[panoId]);
}

// 税込み
function setProductPriceWithTax(price){
    if (price == "") {
        productPrice = "";
    } else {
        num = Number(price);
        num = Math.floor(num * 1.05);
        productPrice = "￥" + num + "～";
    } 
}

// 税込み（～表記なし）
function setProductPriceWithTaxWithoutRange(price){
    if (price == "") {
        productPrice = "";
    } else {
        num = Number(price);
        num = Math.floor(num * 1.05);
        productPrice = "￥" + num;
    } 
}

// ポップアップ表示
function showItemNissen()
{   
    if( $("#myItem").length<=0 ){
        $("body").append("<div id='myItem'></div>");
    }
    
    // div#myItemを表示
    $("div#myItem").show();
    
    var html = "<div id='myItemInner'>";
    
//    html += "<div id='productTitle' style='font-size;16px;font-weight:bold;width:200px;height:16px;overflow:hidden;'>"+productTitle+"</div>";

    if( productImage != "" ){
        html += "<div id='imgprcbox'><img id='productImage' src='"+productImage+"'/>";
    }
    else // レイアウトが崩れないように値がnullでもタグは作る
    {
        html += "<div id='imgprcbox'><img id='productImage' src=''/>";
    }
    
    if( productPrice != "" ){
        html += "<div id='productPrice' >"+productPrice+"</div>";
    }	
    else // レイアウトが崩れないように値がnullでもタグは作る
    {
        html += "<div id='productPrice' ></div>";        
    }
   
    if( productDescription != "" ){
        html += "</div><div id='productDescription' ><p>"+productDescription+"</p></div>";
    } 
    else // レイアウトが崩れないように値がnullでもタグは作る
     {
        html += "</div><div id='productDescription' ><p></p></div>";        
    }
 
    html += "<br clear='all'>";
    html += "<a id='productTwitter' href='javascript:onTweet_nissen();' style='float:left;display:block;background:url(http://storage.panoplaza.com/pvs/btn/tweet.png);width:55px;height:20px;'></a>";
    html += "<a id='productDetail' href='"+productUrl+"' target='_blank' style='float:right;'>"+productDetail+"</a>";
    html += "</div>"; 
    
    $("#myItem").html(html);
    
    title = truncate(productTitle,40);

    tb_show(title,"#TB_inline?height=320&width=310&inlineId=myItem"); 

    $("div#TB_ajaxContent").css("height","auto");
    
    // closeボタンを押したとき
    $("div#TB_closeAjaxWindow").click(function(){
        // popupを非表示にする
        $("div#myItem").hide();
    });
}

// ポップアップ表示(iPhone用)
function showItemNissen_iPhone()
{   
    if( $("#myItem").length<=0 ){
        $("body").append("<div id='myItem'></div>");
    }
    
    // --------------DEBUG---------------
    alert('iPhone用!');
    //-----------------------------------

    // div#myItemを表示
    $("div#myItem").show();
    
    var html = "<div id='myItemInner'>";
    
//    html += "<div id='productTitle' style='font-size;16px;font-weight:bold;width:200px;height:16px;overflow:hidden;'>"+productTitle+"</div>";

    if( productImage != "" ){
        html += "<div id='imgprcbox'><img id='productImage' src='"+productImage+"'/>";
    }
    else // レイアウトが崩れないように値がnullでもタグは作る
    {
        html += "<div id='imgprcbox'><img id='productImage' src=''/>";
    }
    
    if( productPrice != "" ){
        html += "<div id='productPrice' >"+productPrice+"</div>";
    }	
    else // レイアウトが崩れないように値がnullでもタグは作る
    {
        html += "<div id='productPrice' ></div>";        
    }
   
    if( productDescription != "" ){
        html += "</div><div id='productDescription' ><p>"+productDescription+"</p></div>";
    } 
    else // レイアウトが崩れないように値がnullでもタグは作る
     {
        html += "</div><div id='productDescription' ><p></p></div>";        
    }
 
    html += "<br clear='all'>";
    html += "<a id='productTwitter' href='javascript:onTweet_nissen();' style='float:left;display:block;background:url(http://storage.panoplaza.com/pvs/btn/tweet.png);width:55px;height:20px;'></a>";
    html += "<a id='productDetail' href='"+productUrl+"' target='_blank' style='float:right;'>"+productDetail+"</a>";
    html += "</div>"; 
    
    $("#myItem").html(html);
    
    title = truncate(productTitle,40);

    tb_show(title,"#TB_inline?height=320&width=310&inlineId=myItem"); 

    $("div#TB_ajaxContent").css("height","auto");
    
    // closeボタンを押したとき
    $("div#TB_closeAjaxWindow").click(function(){
        // popupを非表示にする
        $("div#myItem").hide();
    });
}


function onTweet_nissen()
{
    var login  = 'kadinche';
    var apiKey = 'R_d20834c58d0bba3fa0c1fbfb95d58cd9';
    bitly = 'http://api.bit.ly/shorten' 
        + '?version=2.0.1&format=json&callback=callback_nissen'
        + '&login=' + login
        + '&apiKey=' + apiKey + '&longUrl=';
    var script = document.createElement('script');
    script.type = 'text/javascript';
    script.src = bitly + encodeURIComponent(productDirect);
    document.body.appendChild(script);
}


function callback_nissen(bitlyResult)
{
	if( hashTag == null ){
		status = encodeURIComponent(productTitle+" "+bitlyResult.results[productDirect]['shortUrl']+" #PanoPlaza");
	}else{
		status = encodeURIComponent(productTitle+" "+bitlyResult.results[productDirect]['shortUrl'] );
	}
	window.open('http://twitter.com/home/?status='+status)
}


